io.stdout:setvbuf('no')
love.graphics.setBackgroundColor(1, 1, 1)
love.window.setMode(1600, 900, {fullscreen = true, resizable = true})

image = love.graphics.newImage("image.png")

imageData = love.image.newImageData("image.png")
width, height = imageData:getDimensions()
map = {}

for x = 1, width do
	map[x] = {}
	for y = 1, height do
		local r,g,b,a = imageData:getPixel(x-1,y-1)
		map[x][y] = math.floor(r+.5)
	end
end

colums = {}
rows = {}

font = love.graphics.newFont(15)
text = love.graphics.newText(font, "")
text:set("0")
fontHeight = text:getHeight()
fontHeightD2 = fontHeight / 2
love.graphics.setFont(font)

yOffset = 0

for x = 1, width do
	colums[x] = {}
	local value = 0
	for y = 1, height do
		if map[x][y] == 0 then
			value = value + 1
		else
			if value > 0 then
				colums[x][#colums[x]+1] = value
				value = 0
			end
		end
	end
	if value > 0 then
		colums[x][#colums[x]+1] = value
	end
	yOffset = math.max(#colums[x] * fontHeight + 10, yOffset)
end

xOffset = 0

for y = 1, height do
	rows[y] = ""
	local value = 0
	local joiner = ""
	for x = 1, width do
		if map[x][y] == 0 then
			value = value + 1
		else
			if value > 0 then
				rows[y] = rows[y] .. joiner .. value
				joiner = " "
				value = 0
			end
		end
	end
	if value > 0 then
		rows[y] = rows[y] .. joiner .. value
	end
	text:set(rows[y])
	local w = text:getWidth() + 10
	xOffset = math.max(w, xOffset)
end

scale = 25
function love.draw()
	_xOffset = xOffset
	_yOffset = yOffset

	love.graphics.setColor(0, 0, 0)

	-- corect ratio line
	local screenWidth, screenHeight = love.graphics.getDimensions()
	local x = screenHeight * 11 / 8.5
	print(x)
	love.graphics.line(x, 0, x, screenHeight)

	-- Draw the image
	-- love.graphics.setColor(1, .8, .8)
	for x = 1, width do
		for y = 1, height do
			-- if x <= 7
			-- or x > width - 7
			-- or y <= 7
			-- or y > height - 7 then
				if map[x][y] == 0 then
					love.graphics.rectangle("fill", (x - 1) * scale + xOffset, (y - 1) * scale + yOffset, scale, scale)
				end
			-- end
		end
	end

	love.graphics.setColor(0, 0, 0)
	-- -- Mouse pos.
	-- mouseX, mouseY = love.mouse.getPosition()
	-- if mouseX > xOffset and mouseY > yOffset then
	-- 	love.graphics.print(
	-- 		"("..(math.floor((mouseX - xOffset) / scale) + 1)..", "..(math.floor((mouseY - yOffset) / scale) + 1)..")",
	-- 		0,
	-- 		0
	-- 	)
	-- end
	
	-- Colum numbers.
	for x, yTable in pairs(colums) do
		local yTableHeight = #yTable
		for y, value in pairs(yTable) do
			text:set(value)
			local w = text:getWidth()
			love.graphics.print(value, (x - 1) * scale + scale / 2 - w / 2 + _xOffset, (yTableHeight - y + 1) * -fontHeight + _yOffset - 5)
		end
	end
	-- Row numbers.
	for y, str in pairs(rows) do
		text:set(str)
		local h = text:getHeight()
		local w = text:getWidth()
		love.graphics.print(str, - w + _xOffset - 5, (y - 1) * scale + scale / 2 - fontHeightD2 + _yOffset)
	end
	-- Main lines
	for x = 1, width+1 do
		local xPos = (x - 1) * scale + _xOffset
		love.graphics.line(xPos, 0, xPos, _yOffset + scale * height)
	end
	for y = 1, height+1 do
		local yPos = (y - 1) * scale + _yOffset
		love.graphics.line(0, yPos, _xOffset + scale * width, yPos)
	end

	-- Colum labels.
	_yOffset = _yOffset + height * scale
	for x = 1, width do
		love.graphics.line(_xOffset, _yOffset, _xOffset, _yOffset + scale)
		text:set(x)
		local w = text:getWidth()
		love.graphics.print(x, _xOffset + scale / 2 - w / 2, _yOffset + 5)
		_xOffset = _xOffset + scale
	end
	love.graphics.line(_xOffset, _yOffset, _xOffset, _yOffset + scale)

	
	-- Row labels.
	_yOffset = yOffset
	_xOffset = xOffset + width * scale
	for x = 1, width do
		love.graphics.line(_xOffset, _yOffset, _xOffset + scale, _yOffset)
		text:set(x)
		local w = text:getWidth()
		love.graphics.print(x, _xOffset + scale / 2 - w / 2, _yOffset + 5)
		_yOffset = _yOffset + scale
	end
	love.graphics.line(_xOffset, _yOffset, _xOffset + scale, _yOffset)

	-- Example 1.
	_yOffset = yOffset
	_xOffset = xOffset + scale * width + 80
	local blocks = {1, 3, 5, 3, 1}
	local tab = {0,1,1,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,1,0}
	for y, value in pairs (blocks) do
		text:set(value)
		local w = text:getWidth()
		love.graphics.print(value, _xOffset + scale / 2 - w / 2 , _yOffset)
		_yOffset = _yOffset + fontHeight
	end
	_yOffset = _yOffset + 5
	love.graphics.line(_xOffset, yOffset, _xOffset, _yOffset)
	love.graphics.line(_xOffset + scale, yOffset, _xOffset + scale, _yOffset)
	love.graphics.setColor(0, 0, 0)
	drawSquaresDown(tab)

	-- Example 2.
	tab = {0}
	local _xOffsetReturn = _xOffset + 80
	_xOffset = _xOffsetReturn
	_yOffset = yOffset
	drawSquaresToTheSide({0})
	love.graphics.print(" = 1", _xOffset + 5, _yOffset + scale / 2 - fontHeightD2)
	---------------------------
	_yOffset = _yOffset + scale + 10
	_xOffset = _xOffsetReturn
	drawSquaresToTheSide({0,1})
	love.graphics.print(" = 2", _xOffset + 5, _yOffset + scale / 2 - fontHeightD2)
	---------------------------
	_yOffset = _yOffset + scale + 10
	_xOffset = _xOffsetReturn
	drawSquaresToTheSide({1,0,1,0})
	love.graphics.print(" = 5", _xOffset + 5, _yOffset + scale / 2 - fontHeightD2)

	_yOffset = _yOffset + 80
	_xOffset = _xOffsetReturn
	love.graphics.print(
		"Locked within the chest lays\na book of great knowledge\nand forgotten heritage.\nUse this page to find the key.\nPut on some music, relax.\nYour birthday book awaits.",
		_xOffset,
		_yOffset
	)

end

function drawSquaresDown(tab)
	love.graphics.line(_xOffset, _yOffset, _xOffset, _yOffset + #tab * scale)
	love.graphics.line(_xOffset + scale , _yOffset, _xOffset + scale , _yOffset + #tab * scale)
	for x, val in pairs(tab) do
		love.graphics.line(_xOffset, _yOffset, _xOffset + scale, _yOffset)
		if val == 0 then
			love.graphics.rectangle("fill", _xOffset, _yOffset, scale, scale)
		end
		_yOffset = _yOffset + scale
	end
	love.graphics.line(_xOffset, _yOffset, _xOffset + scale, _yOffset)
end

function drawSquaresToTheSide(tab)
	love.graphics.line(_xOffset, _yOffset, _xOffset + #tab * scale, _yOffset)
	love.graphics.line(_xOffset, _yOffset + scale, _xOffset + #tab * scale, _yOffset + scale)
	for x, val in pairs(tab) do
		love.graphics.line(_xOffset, _yOffset, _xOffset, _yOffset + scale)
		if val == 0 then
			love.graphics.rectangle("fill", _xOffset, _yOffset, scale, scale)
		end
		_xOffset = _xOffset + scale
	end
	love.graphics.line(_xOffset, _yOffset, _xOffset, _yOffset + scale)
end

function love.keypressed(key, scancode, isrepeat)
    if key == "escape" then
        love.window.close()
    end
end