blinkTimer = -200

faceXOffset = 250
faceYOffset = 100

function drawFace()
	mouseX, mouseY = love.mouse.getPosition()

	love.graphics.setColor(1, 1, 1)
	local screenWidth, screenHeight = love.graphics.getDimensions()
	local screenWidthD3 = screenWidth/3.2
	local screenHeightD3 = screenHeight/3.2

	if blinkTimer < 0 then
		blinkTimer = blinkTimer + 1
	else
		if blinkTimer == 0 then
			blinkTimer = math.random(100, 500)
		end
		if blinkTimer == 1 then
			blinkTimer = -10
		end
		blinkTimer = blinkTimer - 1
	end

	drawEye(screenWidthD3 + faceXOffset, screenHeightD3 + faceYOffset)
	drawEye(screenWidth - screenWidthD3 + faceXOffset, screenHeightD3 + faceYOffset)

	love.graphics.arc("line", "open", 
		screenWidth/2+deathNoise() + faceXOffset, 
		screenHeightD3+screenHeightD3/2+deathNoise() + faceYOffset, 30, math.pi-.5, .5, 20)

	drawMouth(screenWidth/2 + faceXOffset, screenHeightD3+screenHeightD3 + faceYOffset)
end

expression = 1
function drawMouth(x,y)
	if expression == 0 then
		love.graphics.arc(
			"line", 
			"open", 
			x+deathNoise(), 
			y+deathNoise()-300, 
			300, math.pi/2+.3, math.pi/2-.3, 20
		)
	elseif expression == 1 then
		love.graphics.ellipse("line", x + deathNoise(), y + deathNoise(), 100, 50, 40)
	elseif expression == 2 then
		love.graphics.circle("line", x + deathNoise(), y + deathNoise(), 40, 40)
	elseif expression == 3 then
		love.graphics.ellipse("line", x + deathNoise(), y + deathNoise(), 100, 30, 40)
		love.graphics.arc("line", "open", x + deathNoise(), y + 20, 50 + deathNoise(), math.pi, math.pi+math.pi, 20)
	elseif expression == 4 then
		love.graphics.line(x - 70 + deathNoise(), y + deathNoise(), x + 70 + deathNoise(), y + deathNoise())
	end
end


function drawEye(x,y)
	local radius = 90
	local offset = 30
	local angleCutoff = math.pi/9.2

	love.graphics.setLineWidth( 3 )
	love.graphics.arc("line", "open", x + deathNoise(), y - offset + deathNoise(), radius, angleCutoff, math.pi-angleCutoff, 20)

	local eyelashSign = 1
	if blinkTimer > 0 then
		love.graphics.arc("line", "open", x + deathNoise(), y + offset + deathNoise(), radius, math.pi+angleCutoff, math.pi+math.pi-angleCutoff, 20)
		love.graphics.circle("line", x + (mouseX - x)*.05 + deathNoise(), y + (mouseY - y)*.05 + deathNoise(), 30, 40)
		love.graphics.circle("line", x + (mouseX - x)*.05 + deathNoise(), y + (mouseY - y)*.05 + deathNoise(), 10, 40)
		eyelashSign = -1
	end

	local eyelashLength = 30
	local eyelashSpacing = radius+15
	local angle = angleCutoff*2
	local angleMax = math.pi-angleCutoff-angleCutoff
	local angleDelta = (angleMax-angle) / 4
	while angle <= angleMax do
		local dx = math.cos(angle)
		local dy = math.sin(angle)
		love.graphics.line(
			x + dx * (eyelashSpacing) + deathNoise(), 
			y + (dy * (eyelashSpacing) - offset) * eyelashSign + deathNoise(), 
			x + dx * (radius + eyelashLength) + deathNoise(), 
			y + (dy * (radius + eyelashLength) - offset) * eyelashSign + deathNoise()
		)
		angle = angle + angleDelta
	end
end