love.window.setMode(1600, 900, {fullscreen = true, resizable = true})

require("face")
require("voice")

love.graphics.setFont(love.graphics.newFont(50))
question_font = love.graphics.newFont(50)
question_text = love.graphics.newText(question_font)
typed_font = love.graphics.getFont ()
typed_text = love.graphics.newText(typed_font)
typed_text:add("0")
typed_text_height = typed_text:getHeight()
typed_text_width = typed_text:getWidth()
typed_text_string = ""
small_font = love.graphics.newFont(35)
small_text = love.graphics.newText(small_font)
small_text:add("0")
small_text_height = small_text:getHeight()

question_index = 1
questions = {
    'its time i asked the questions.  say "ready" when you are ready.',
    'what is (23, 29)',
    'what is (11-12, 14)',
    'what is (29, 13-17)',
    "ok, what about ((27-30, 5)-(11-15, 23), (5, 24-27)) i sware this one wasn't on purpose",
    "who has eyes, a mouth, and a nose, but no ears.  tell me their name.",
    "the key is in a tree in the back yarrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr"
}

answers = {
    'ready',
    '1',
    '3',
    '16',
    '69',
    'mister bob'
}

local name = "my name is mister bob"
local qr_code_pos = "its a position on the qr code"
responces = {
    help = "no, you do not get any help",
    hello = "hi",
    hi = "hello",
    ["what is your name"] = name,
    ["who are you"] = name,
    ["what are you"] = "excuse you, i am a person",
    ["what is your favorite color"] = "pink",
    ["what is your favorite hotel"] = "the loveland hotel",
    ["what does : mean"] = "its a position on the qr code",
    ["what does the : mean"] = "its a position on the qr code",
    ["do you know cat"] = "cat is my best friend",
    ["do you like cat"] = "cat is my best friend",
    ["what is your favorite video game"] = "minecraft",
    ["i don't know"] = "nope, that's not guna slide",
    ["how old are you"] = "i am less than a day old",
    ["what is your age"] = "i am less than a day old",
    what = "huh",
    huh = "what",
    ["where are you"] = "in the spaceless void that is your computer",
    [answers[1]] = "alright, here we go",
    [answers[2]] = "good :)",
    [answers[3]] = "yup yup, thats it.  alright try this one",
    [answers[4]] = "awsome, two more left",
    [answers[5]] = "epic. now for the last question",
    [answers[6]] = "yes that's it.  me.  wonderful, beutiful, me."
}

function love.load(args, unfilteredArgs)
    update_typed_text_string("")
    memory = {""}
end

death = 0
function deathNoise()
    return math.random(-1.0, 1.0) * death
end


question_delay = 2000
function love.update(dt)
    update_computer_voice()

    if question_delay > 0 then
        question_delay = question_delay - 1
    elseif question_delay == 0 then
        if question_index > #questions then
            computer_voice_string = "all done"
        else
            computer_voice_string = questions[question_index]
        end
        question_text:set(computer_voice_string)
        question_delay = -1
    end
end


function love.textinput(t)
    update_typed_text_string(typed_text_string .. t)
end


function update_typed_text_string(t)
    typed_text_string = t
    typed_text:set(typed_text_string)
    typed_text_width = typed_text:getWidth()
end


function love.keypressed(key, scancode, isrepeat)
    local key_sound = voice_sounds[key]
    if not (key_sound == nil) then
        key_sound:setPitch(math.random()+2)
        key_sound:stop()
        key_sound:play()
    end
    
    if key == "backspace" then
        update_typed_text_string(typed_text_string:sub(1, -2))
    elseif key == "return" then
        local responce = responces[typed_text_string]
        
        local middle_string = ""
       
        local string_error = is_string_valid_return_error(typed_text_string)
        if not (string_error == "") then
            responce = string_error
        end
        if answers[question_index] == typed_text_string then
            question_delay = 200
            question_index = question_index + 1
            question_text:set("")
        end
        if not (responce == nil) then
            computer_voice_string = responce
        end
        if not (responce == nil) then
            middle_string = " -> "
        end
        memory[#memory+1] = {{1,1,1}, typed_text_string, {.8,.8,0}, middle_string, {1,0,0}, responce}
        if #memory > 21 then
            table.remove(memory, 1)
        end
        update_typed_text_string("")

    elseif key == "escape" then
        love.window.close()
    end
end


time = 0
function love.draw()
    if question_index >= 7 then
        death = death + .05
        if computer_voice_string == "" and question_delay == -1 then
            love.window.close()
        end
    end

    --
    local y = 0

    love.graphics.setColor(1, 0, 0)
    time = time + .1
    love.graphics.draw(question_text,0 + deathNoise(),y + deathNoise(), 0, 1, 1, 0, 0, math.sin(time) * -.1)

    y = y + typed_text_height + 30
    
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(typed_text,0+ deathNoise(),y + deathNoise())
    love.graphics.rectangle("line", typed_text_width + deathNoise(), y + deathNoise(), 3, typed_text_height)

    love.graphics.setColor(.8, .8, .8)
    y = y + (#memory * small_text_height) + typed_text_height
    for key, text in pairs(memory) do
        small_text:set(text)
        love.graphics.draw(small_text, 20 + deathNoise(), y + deathNoise(), 0, 1, 1, 0, 0, -.3)
        y = y - small_text_height
    end

    drawFace()
end


function is_string_valid_return_error(s)
    local last_char = s:sub(#s, #s)
    if last_char == "." 
    or last_char == "!"
    or last_char == "?" then
        return "don't use any punctuation"
    elseif string.find(s, "A")
    or string.find(s, "B") then
        return "don't use capital letters"
    end
    return ""
end


